-------------------------------------------------------------------------------
-- system_csc_rgb_to_ycrcb422_0_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library csc_rgb_to_ycrcb422_v1_01_b;
use csc_rgb_to_ycrcb422_v1_01_b.all;

entity system_csc_rgb_to_ycrcb422_0_wrapper is
  port (
    clk : in std_logic;
    ce : in std_logic;
    vblank_i : in std_logic;
    hblank_i : in std_logic;
    vsync_i : in std_logic;
    hsync_i : in std_logic;
    active_video_i : in std_logic;
    video_data_i : in std_logic_vector(23 downto 0);
    vblank_o : out std_logic;
    hblank_o : out std_logic;
    vsync_o : out std_logic;
    hsync_o : out std_logic;
    active_video_o : out std_logic;
    video_data_o : out std_logic_vector(15 downto 0);
    debug_o : out std_logic_vector(26 downto 0)
  );
end system_csc_rgb_to_ycrcb422_0_wrapper;

architecture STRUCTURE of system_csc_rgb_to_ycrcb422_0_wrapper is

  component csc_rgb_to_ycrcb422 is
    port (
      clk : in std_logic;
      ce : in std_logic;
      vblank_i : in std_logic;
      hblank_i : in std_logic;
      vsync_i : in std_logic;
      hsync_i : in std_logic;
      active_video_i : in std_logic;
      video_data_i : in std_logic_vector(23 downto 0);
      vblank_o : out std_logic;
      hblank_o : out std_logic;
      vsync_o : out std_logic;
      hsync_o : out std_logic;
      active_video_o : out std_logic;
      video_data_o : out std_logic_vector(15 downto 0);
      debug_o : out std_logic_vector(26 downto 0)
    );
  end component;

begin

  csc_rgb_to_ycrcb422_0 : csc_rgb_to_ycrcb422
    port map (
      clk => clk,
      ce => ce,
      vblank_i => vblank_i,
      hblank_i => hblank_i,
      vsync_i => vsync_i,
      hsync_i => hsync_i,
      active_video_i => active_video_i,
      video_data_i => video_data_i,
      vblank_o => vblank_o,
      hblank_o => hblank_o,
      vsync_o => vsync_o,
      hsync_o => hsync_o,
      active_video_o => active_video_o,
      video_data_o => video_data_o,
      debug_o => debug_o
    );

end architecture STRUCTURE;

