-------------------------------------------------------------------------------
-- system_hdmi_interface_0_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library hdmi_interface_v1_01_a;
use hdmi_interface_v1_01_a.all;

entity system_hdmi_interface_0_wrapper is
  port (
    clk : in std_logic;
    ce : in std_logic;
    de_i : in std_logic;
    vsync_i : in std_logic;
    hsync_i : in std_logic;
    Y_i : in std_logic_vector(7 downto 0);
    CrCb_i : in std_logic_vector(7 downto 0);
    hdmi_ext_int : in std_logic;
    hdmi_int : out std_logic;
    hdmi_de : out std_logic;
    hdmi_vsync : out std_logic;
    hdmi_hsync : out std_logic;
    hdmi_data : out std_logic_vector(15 downto 0);
    hdmi_clk : out std_logic;
    EXT_SMA_CLK_P : out std_logic
  );
end system_hdmi_interface_0_wrapper;

architecture STRUCTURE of system_hdmi_interface_0_wrapper is

  component hdmi_interface is
    port (
      clk : in std_logic;
      ce : in std_logic;
      de_i : in std_logic;
      vsync_i : in std_logic;
      hsync_i : in std_logic;
      Y_i : in std_logic_vector(7 downto 0);
      CrCb_i : in std_logic_vector(7 downto 0);
      hdmi_ext_int : in std_logic;
      hdmi_int : out std_logic;
      hdmi_de : out std_logic;
      hdmi_vsync : out std_logic;
      hdmi_hsync : out std_logic;
      hdmi_data : out std_logic_vector(15 downto 0);
      hdmi_clk : out std_logic;
      EXT_SMA_CLK_P : out std_logic
    );
  end component;

begin

  hdmi_interface_0 : hdmi_interface
    port map (
      clk => clk,
      ce => ce,
      de_i => de_i,
      vsync_i => vsync_i,
      hsync_i => hsync_i,
      Y_i => Y_i,
      CrCb_i => CrCb_i,
      hdmi_ext_int => hdmi_ext_int,
      hdmi_int => hdmi_int,
      hdmi_de => hdmi_de,
      hdmi_vsync => hdmi_vsync,
      hdmi_hsync => hdmi_hsync,
      hdmi_data => hdmi_data,
      hdmi_clk => hdmi_clk,
      EXT_SMA_CLK_P => EXT_SMA_CLK_P
    );

end architecture STRUCTURE;

