-------------------------------------------------------------------------------
-- system_osd_0_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library axi_osd_v2_00_a;
use axi_osd_v2_00_a.all;

entity system_osd_0_wrapper is
  port (
    S_AXI_ACLK : in std_logic;
    S_AXI_ARESETN : in std_logic;
    S_AXI_AWADDR : in std_logic_vector(31 downto 0);
    S_AXI_AWVALID : in std_logic;
    S_AXI_AWREADY : out std_logic;
    S_AXI_WDATA : in std_logic_vector(31 downto 0);
    S_AXI_WSTRB : in std_logic_vector(3 downto 0);
    S_AXI_WVALID : in std_logic;
    S_AXI_WREADY : out std_logic;
    S_AXI_BRESP : out std_logic_vector(1 downto 0);
    S_AXI_BVALID : out std_logic;
    S_AXI_BREADY : in std_logic;
    S_AXI_ARADDR : in std_logic_vector(31 downto 0);
    S_AXI_ARVALID : in std_logic;
    S_AXI_ARREADY : out std_logic;
    S_AXI_RDATA : out std_logic_vector(31 downto 0);
    S_AXI_RRESP : out std_logic_vector(1 downto 0);
    S_AXI_RVALID : out std_logic;
    S_AXI_RREADY : in std_logic;
    IP2INTC_Irpt : out std_logic;
    vblank_in : in std_logic;
    vsync_in : in std_logic;
    hblank_in : in std_logic;
    hsync_in : in std_logic;
    active_video_in : in std_logic;
    active_chroma_in : in std_logic;
    video_data_in : in std_logic_vector(23 downto 0);
    vfbc_rd0_clk : out std_logic;
    vfbc_rd0_reset : out std_logic;
    vfbc_rd0_read : out std_logic;
    vfbc_rd0_data : in std_logic_vector(31 downto 0);
    vfbc_rd0_empty : in std_logic;
    vfbc_rd1_clk : out std_logic;
    vfbc_rd1_reset : out std_logic;
    vfbc_rd1_read : out std_logic;
    vfbc_rd1_data : in std_logic_vector(31 downto 0);
    vfbc_rd1_empty : in std_logic;
    vfbc_rd2_clk : out std_logic;
    vfbc_rd2_reset : out std_logic;
    vfbc_rd2_read : out std_logic;
    vfbc_rd2_data : in std_logic_vector(31 downto 0);
    vfbc_rd2_empty : in std_logic;
    vfbc_rd3_clk : out std_logic;
    vfbc_rd3_reset : out std_logic;
    vfbc_rd3_read : out std_logic;
    vfbc_rd3_data : in std_logic_vector(31 downto 0);
    vfbc_rd3_empty : in std_logic;
    vfbc_rd4_clk : out std_logic;
    vfbc_rd4_reset : out std_logic;
    vfbc_rd4_read : out std_logic;
    vfbc_rd4_data : in std_logic_vector(31 downto 0);
    vfbc_rd4_empty : in std_logic;
    vfbc_rd5_clk : out std_logic;
    vfbc_rd5_reset : out std_logic;
    vfbc_rd5_read : out std_logic;
    vfbc_rd5_data : in std_logic_vector(31 downto 0);
    vfbc_rd5_empty : in std_logic;
    vfbc_rd6_clk : out std_logic;
    vfbc_rd6_reset : out std_logic;
    vfbc_rd6_read : out std_logic;
    vfbc_rd6_data : in std_logic_vector(31 downto 0);
    vfbc_rd6_empty : in std_logic;
    vfbc_rd7_clk : out std_logic;
    vfbc_rd7_reset : out std_logic;
    vfbc_rd7_read : out std_logic;
    vfbc_rd7_data : in std_logic_vector(31 downto 0);
    vfbc_rd7_empty : in std_logic;
    vfbc_wd_clk : out std_logic;
    vfbc_wd_reset : out std_logic;
    vfbc_wd_write : out std_logic;
    vfbc_wd_data : out std_logic_vector(31 downto 0);
    vfbc_wd_almost_full : in std_logic;
    video_clk_out : out std_logic;
    vblank_out : out std_logic;
    vsync_out : out std_logic;
    hblank_out : out std_logic;
    hsync_out : out std_logic;
    active_video_out : out std_logic;
    active_chroma_out : out std_logic;
    video_data_out : out std_logic_vector(23 downto 0);
    clk : in std_logic;
    ce : in std_logic
  );
end system_osd_0_wrapper;

architecture STRUCTURE of system_osd_0_wrapper is

  component axi_osd is
    generic (
      C_DATA_WIDTH : INTEGER;
      C_NUM_LAYERS : INTEGER;
      C_NUM_DATA_CHANNELS : INTEGER;
      C_SCREEN_WIDTH : INTEGER;
      C_READ_FIFO_LATENCY : INTEGER;
      C_ALPHA_CHANNEL_EN : INTEGER;
      C_OUTPUT_MODE : INTEGER;
      C_VFBC_RD_DATA_WIDTH : INTEGER;
      C_VFBC_WD_DATA_WIDTH : INTEGER;
      C_LAYER0_TYPE : INTEGER;
      C_LAYER1_TYPE : INTEGER;
      C_LAYER2_TYPE : INTEGER;
      C_LAYER3_TYPE : INTEGER;
      C_LAYER4_TYPE : INTEGER;
      C_LAYER5_TYPE : INTEGER;
      C_LAYER6_TYPE : INTEGER;
      C_LAYER7_TYPE : INTEGER;
      C_LAYER0_IMEM_SIZE : INTEGER;
      C_LAYER0_INS_BOX_EN : INTEGER;
      C_LAYER0_INS_LINE_EN : INTEGER;
      C_LAYER0_INS_TEXT_EN : INTEGER;
      C_LAYER0_CLUT_SIZE : INTEGER;
      C_LAYER0_CLUT_MEMTYPE : INTEGER;
      C_LAYER0_FONT_NUM_CHARS : INTEGER;
      C_LAYER0_FONT_WIDTH : INTEGER;
      C_LAYER0_FONT_HEIGHT : INTEGER;
      C_LAYER0_FONT_BPP : INTEGER;
      C_LAYER0_FONT_ASCII_OFFSET : INTEGER;
      C_LAYER0_TEXT_NUM_STRINGS : INTEGER;
      C_LAYER0_TEXT_MAX_STRING_LENGTH : INTEGER;
      C_LAYER1_IMEM_SIZE : INTEGER;
      C_LAYER1_INS_BOX_EN : INTEGER;
      C_LAYER1_INS_LINE_EN : INTEGER;
      C_LAYER1_INS_TEXT_EN : INTEGER;
      C_LAYER1_CLUT_SIZE : INTEGER;
      C_LAYER1_CLUT_MEMTYPE : INTEGER;
      C_LAYER1_FONT_NUM_CHARS : INTEGER;
      C_LAYER1_FONT_WIDTH : INTEGER;
      C_LAYER1_FONT_HEIGHT : INTEGER;
      C_LAYER1_FONT_BPP : INTEGER;
      C_LAYER1_FONT_ASCII_OFFSET : INTEGER;
      C_LAYER1_TEXT_NUM_STRINGS : INTEGER;
      C_LAYER1_TEXT_MAX_STRING_LENGTH : INTEGER;
      C_LAYER2_IMEM_SIZE : INTEGER;
      C_LAYER2_INS_BOX_EN : INTEGER;
      C_LAYER2_INS_LINE_EN : INTEGER;
      C_LAYER2_INS_TEXT_EN : INTEGER;
      C_LAYER2_CLUT_SIZE : INTEGER;
      C_LAYER2_CLUT_MEMTYPE : INTEGER;
      C_LAYER2_FONT_NUM_CHARS : INTEGER;
      C_LAYER2_FONT_WIDTH : INTEGER;
      C_LAYER2_FONT_HEIGHT : INTEGER;
      C_LAYER2_FONT_BPP : INTEGER;
      C_LAYER2_FONT_ASCII_OFFSET : INTEGER;
      C_LAYER2_TEXT_NUM_STRINGS : INTEGER;
      C_LAYER2_TEXT_MAX_STRING_LENGTH : INTEGER;
      C_LAYER3_IMEM_SIZE : INTEGER;
      C_LAYER3_INS_BOX_EN : INTEGER;
      C_LAYER3_INS_LINE_EN : INTEGER;
      C_LAYER3_INS_TEXT_EN : INTEGER;
      C_LAYER3_CLUT_SIZE : INTEGER;
      C_LAYER3_CLUT_MEMTYPE : INTEGER;
      C_LAYER3_FONT_NUM_CHARS : INTEGER;
      C_LAYER3_FONT_WIDTH : INTEGER;
      C_LAYER3_FONT_HEIGHT : INTEGER;
      C_LAYER3_FONT_BPP : INTEGER;
      C_LAYER3_FONT_ASCII_OFFSET : INTEGER;
      C_LAYER3_TEXT_NUM_STRINGS : INTEGER;
      C_LAYER3_TEXT_MAX_STRING_LENGTH : INTEGER;
      C_LAYER4_IMEM_SIZE : INTEGER;
      C_LAYER4_INS_BOX_EN : INTEGER;
      C_LAYER4_INS_LINE_EN : INTEGER;
      C_LAYER4_INS_TEXT_EN : INTEGER;
      C_LAYER4_CLUT_SIZE : INTEGER;
      C_LAYER4_CLUT_MEMTYPE : INTEGER;
      C_LAYER4_FONT_NUM_CHARS : INTEGER;
      C_LAYER4_FONT_WIDTH : INTEGER;
      C_LAYER4_FONT_HEIGHT : INTEGER;
      C_LAYER4_FONT_BPP : INTEGER;
      C_LAYER4_FONT_ASCII_OFFSET : INTEGER;
      C_LAYER4_TEXT_NUM_STRINGS : INTEGER;
      C_LAYER4_TEXT_MAX_STRING_LENGTH : INTEGER;
      C_LAYER5_IMEM_SIZE : INTEGER;
      C_LAYER5_INS_BOX_EN : INTEGER;
      C_LAYER5_INS_LINE_EN : INTEGER;
      C_LAYER5_INS_TEXT_EN : INTEGER;
      C_LAYER5_CLUT_SIZE : INTEGER;
      C_LAYER5_CLUT_MEMTYPE : INTEGER;
      C_LAYER5_FONT_NUM_CHARS : INTEGER;
      C_LAYER5_FONT_WIDTH : INTEGER;
      C_LAYER5_FONT_HEIGHT : INTEGER;
      C_LAYER5_FONT_BPP : INTEGER;
      C_LAYER5_FONT_ASCII_OFFSET : INTEGER;
      C_LAYER5_TEXT_NUM_STRINGS : INTEGER;
      C_LAYER5_TEXT_MAX_STRING_LENGTH : INTEGER;
      C_LAYER6_IMEM_SIZE : INTEGER;
      C_LAYER6_INS_BOX_EN : INTEGER;
      C_LAYER6_INS_LINE_EN : INTEGER;
      C_LAYER6_INS_TEXT_EN : INTEGER;
      C_LAYER6_CLUT_SIZE : INTEGER;
      C_LAYER6_CLUT_MEMTYPE : INTEGER;
      C_LAYER6_FONT_NUM_CHARS : INTEGER;
      C_LAYER6_FONT_WIDTH : INTEGER;
      C_LAYER6_FONT_HEIGHT : INTEGER;
      C_LAYER6_FONT_BPP : INTEGER;
      C_LAYER6_FONT_ASCII_OFFSET : INTEGER;
      C_LAYER6_TEXT_NUM_STRINGS : INTEGER;
      C_LAYER6_TEXT_MAX_STRING_LENGTH : INTEGER;
      C_LAYER7_IMEM_SIZE : INTEGER;
      C_LAYER7_INS_BOX_EN : INTEGER;
      C_LAYER7_INS_LINE_EN : INTEGER;
      C_LAYER7_INS_TEXT_EN : INTEGER;
      C_LAYER7_CLUT_SIZE : INTEGER;
      C_LAYER7_CLUT_MEMTYPE : INTEGER;
      C_LAYER7_FONT_NUM_CHARS : INTEGER;
      C_LAYER7_FONT_WIDTH : INTEGER;
      C_LAYER7_FONT_HEIGHT : INTEGER;
      C_LAYER7_FONT_BPP : INTEGER;
      C_LAYER7_FONT_ASCII_OFFSET : INTEGER;
      C_LAYER7_TEXT_NUM_STRINGS : INTEGER;
      C_LAYER7_TEXT_MAX_STRING_LENGTH : INTEGER;
      C_BASEADDR : std_logic_vector;
      C_HIGHADDR : std_logic_vector;
      C_S_AXI_ADDR_WIDTH : INTEGER;
      C_S_AXI_DATA_WIDTH : INTEGER;
      C_S_AXI_CLK_FREQ_HZ : INTEGER;
      C_FAMILY : STRING
    );
    port (
      S_AXI_ACLK : in std_logic;
      S_AXI_ARESETN : in std_logic;
      S_AXI_AWADDR : in std_logic_vector((C_S_AXI_ADDR_WIDTH-1) downto 0);
      S_AXI_AWVALID : in std_logic;
      S_AXI_AWREADY : out std_logic;
      S_AXI_WDATA : in std_logic_vector((C_S_AXI_DATA_WIDTH-1) downto 0);
      S_AXI_WSTRB : in std_logic_vector(((C_S_AXI_DATA_WIDTH/8)-1) downto 0);
      S_AXI_WVALID : in std_logic;
      S_AXI_WREADY : out std_logic;
      S_AXI_BRESP : out std_logic_vector(1 downto 0);
      S_AXI_BVALID : out std_logic;
      S_AXI_BREADY : in std_logic;
      S_AXI_ARADDR : in std_logic_vector((C_S_AXI_ADDR_WIDTH-1) downto 0);
      S_AXI_ARVALID : in std_logic;
      S_AXI_ARREADY : out std_logic;
      S_AXI_RDATA : out std_logic_vector((C_S_AXI_DATA_WIDTH-1) downto 0);
      S_AXI_RRESP : out std_logic_vector(1 downto 0);
      S_AXI_RVALID : out std_logic;
      S_AXI_RREADY : in std_logic;
      IP2INTC_Irpt : out std_logic;
      vblank_in : in std_logic;
      vsync_in : in std_logic;
      hblank_in : in std_logic;
      hsync_in : in std_logic;
      active_video_in : in std_logic;
      active_chroma_in : in std_logic;
      video_data_in : in std_logic_vector((C_NUM_DATA_CHANNELS+C_ALPHA_CHANNEL_EN)*C_DATA_WIDTH-1 downto 0);
      vfbc_rd0_clk : out std_logic;
      vfbc_rd0_reset : out std_logic;
      vfbc_rd0_read : out std_logic;
      vfbc_rd0_data : in std_logic_vector(C_VFBC_RD_DATA_WIDTH-1 downto 0);
      vfbc_rd0_empty : in std_logic;
      vfbc_rd1_clk : out std_logic;
      vfbc_rd1_reset : out std_logic;
      vfbc_rd1_read : out std_logic;
      vfbc_rd1_data : in std_logic_vector(C_VFBC_RD_DATA_WIDTH-1 downto 0);
      vfbc_rd1_empty : in std_logic;
      vfbc_rd2_clk : out std_logic;
      vfbc_rd2_reset : out std_logic;
      vfbc_rd2_read : out std_logic;
      vfbc_rd2_data : in std_logic_vector(C_VFBC_RD_DATA_WIDTH-1 downto 0);
      vfbc_rd2_empty : in std_logic;
      vfbc_rd3_clk : out std_logic;
      vfbc_rd3_reset : out std_logic;
      vfbc_rd3_read : out std_logic;
      vfbc_rd3_data : in std_logic_vector(C_VFBC_RD_DATA_WIDTH-1 downto 0);
      vfbc_rd3_empty : in std_logic;
      vfbc_rd4_clk : out std_logic;
      vfbc_rd4_reset : out std_logic;
      vfbc_rd4_read : out std_logic;
      vfbc_rd4_data : in std_logic_vector(C_VFBC_RD_DATA_WIDTH-1 downto 0);
      vfbc_rd4_empty : in std_logic;
      vfbc_rd5_clk : out std_logic;
      vfbc_rd5_reset : out std_logic;
      vfbc_rd5_read : out std_logic;
      vfbc_rd5_data : in std_logic_vector(C_VFBC_RD_DATA_WIDTH-1 downto 0);
      vfbc_rd5_empty : in std_logic;
      vfbc_rd6_clk : out std_logic;
      vfbc_rd6_reset : out std_logic;
      vfbc_rd6_read : out std_logic;
      vfbc_rd6_data : in std_logic_vector(C_VFBC_RD_DATA_WIDTH-1 downto 0);
      vfbc_rd6_empty : in std_logic;
      vfbc_rd7_clk : out std_logic;
      vfbc_rd7_reset : out std_logic;
      vfbc_rd7_read : out std_logic;
      vfbc_rd7_data : in std_logic_vector(C_VFBC_RD_DATA_WIDTH-1 downto 0);
      vfbc_rd7_empty : in std_logic;
      vfbc_wd_clk : out std_logic;
      vfbc_wd_reset : out std_logic;
      vfbc_wd_write : out std_logic;
      vfbc_wd_data : out std_logic_vector(C_VFBC_WD_DATA_WIDTH-1 downto 0);
      vfbc_wd_almost_full : in std_logic;
      video_clk_out : out std_logic;
      vblank_out : out std_logic;
      vsync_out : out std_logic;
      hblank_out : out std_logic;
      hsync_out : out std_logic;
      active_video_out : out std_logic;
      active_chroma_out : out std_logic;
      video_data_out : out std_logic_vector(C_NUM_DATA_CHANNELS*C_DATA_WIDTH-1 downto 0);
      clk : in std_logic;
      ce : in std_logic
    );
  end component;

begin

  osd_0 : axi_osd
    generic map (
      C_DATA_WIDTH => 8,
      C_NUM_LAYERS => 3,
      C_NUM_DATA_CHANNELS => 3,
      C_SCREEN_WIDTH => 1280,
      C_READ_FIFO_LATENCY => 1,
      C_ALPHA_CHANNEL_EN => 0,
      C_OUTPUT_MODE => 1,
      C_VFBC_RD_DATA_WIDTH => 32,
      C_VFBC_WD_DATA_WIDTH => 32,
      C_LAYER0_TYPE => 2,
      C_LAYER1_TYPE => 2,
      C_LAYER2_TYPE => 2,
      C_LAYER3_TYPE => 2,
      C_LAYER4_TYPE => 2,
      C_LAYER5_TYPE => 2,
      C_LAYER6_TYPE => 2,
      C_LAYER7_TYPE => 2,
      C_LAYER0_IMEM_SIZE => 48,
      C_LAYER0_INS_BOX_EN => 1,
      C_LAYER0_INS_LINE_EN => 0,
      C_LAYER0_INS_TEXT_EN => 1,
      C_LAYER0_CLUT_SIZE => 16,
      C_LAYER0_CLUT_MEMTYPE => 2,
      C_LAYER0_FONT_NUM_CHARS => 96,
      C_LAYER0_FONT_WIDTH => 8,
      C_LAYER0_FONT_HEIGHT => 8,
      C_LAYER0_FONT_BPP => 1,
      C_LAYER0_FONT_ASCII_OFFSET => 32,
      C_LAYER0_TEXT_NUM_STRINGS => 8,
      C_LAYER0_TEXT_MAX_STRING_LENGTH => 32,
      C_LAYER1_IMEM_SIZE => 48,
      C_LAYER1_INS_BOX_EN => 1,
      C_LAYER1_INS_LINE_EN => 0,
      C_LAYER1_INS_TEXT_EN => 1,
      C_LAYER1_CLUT_SIZE => 16,
      C_LAYER1_CLUT_MEMTYPE => 2,
      C_LAYER1_FONT_NUM_CHARS => 96,
      C_LAYER1_FONT_WIDTH => 8,
      C_LAYER1_FONT_HEIGHT => 8,
      C_LAYER1_FONT_BPP => 1,
      C_LAYER1_FONT_ASCII_OFFSET => 32,
      C_LAYER1_TEXT_NUM_STRINGS => 8,
      C_LAYER1_TEXT_MAX_STRING_LENGTH => 32,
      C_LAYER2_IMEM_SIZE => 48,
      C_LAYER2_INS_BOX_EN => 1,
      C_LAYER2_INS_LINE_EN => 0,
      C_LAYER2_INS_TEXT_EN => 1,
      C_LAYER2_CLUT_SIZE => 16,
      C_LAYER2_CLUT_MEMTYPE => 2,
      C_LAYER2_FONT_NUM_CHARS => 96,
      C_LAYER2_FONT_WIDTH => 8,
      C_LAYER2_FONT_HEIGHT => 8,
      C_LAYER2_FONT_BPP => 1,
      C_LAYER2_FONT_ASCII_OFFSET => 32,
      C_LAYER2_TEXT_NUM_STRINGS => 8,
      C_LAYER2_TEXT_MAX_STRING_LENGTH => 32,
      C_LAYER3_IMEM_SIZE => 48,
      C_LAYER3_INS_BOX_EN => 1,
      C_LAYER3_INS_LINE_EN => 0,
      C_LAYER3_INS_TEXT_EN => 1,
      C_LAYER3_CLUT_SIZE => 16,
      C_LAYER3_CLUT_MEMTYPE => 2,
      C_LAYER3_FONT_NUM_CHARS => 96,
      C_LAYER3_FONT_WIDTH => 8,
      C_LAYER3_FONT_HEIGHT => 8,
      C_LAYER3_FONT_BPP => 1,
      C_LAYER3_FONT_ASCII_OFFSET => 32,
      C_LAYER3_TEXT_NUM_STRINGS => 8,
      C_LAYER3_TEXT_MAX_STRING_LENGTH => 32,
      C_LAYER4_IMEM_SIZE => 48,
      C_LAYER4_INS_BOX_EN => 1,
      C_LAYER4_INS_LINE_EN => 0,
      C_LAYER4_INS_TEXT_EN => 1,
      C_LAYER4_CLUT_SIZE => 16,
      C_LAYER4_CLUT_MEMTYPE => 2,
      C_LAYER4_FONT_NUM_CHARS => 96,
      C_LAYER4_FONT_WIDTH => 8,
      C_LAYER4_FONT_HEIGHT => 8,
      C_LAYER4_FONT_BPP => 1,
      C_LAYER4_FONT_ASCII_OFFSET => 32,
      C_LAYER4_TEXT_NUM_STRINGS => 8,
      C_LAYER4_TEXT_MAX_STRING_LENGTH => 32,
      C_LAYER5_IMEM_SIZE => 48,
      C_LAYER5_INS_BOX_EN => 1,
      C_LAYER5_INS_LINE_EN => 0,
      C_LAYER5_INS_TEXT_EN => 1,
      C_LAYER5_CLUT_SIZE => 16,
      C_LAYER5_CLUT_MEMTYPE => 2,
      C_LAYER5_FONT_NUM_CHARS => 96,
      C_LAYER5_FONT_WIDTH => 8,
      C_LAYER5_FONT_HEIGHT => 8,
      C_LAYER5_FONT_BPP => 1,
      C_LAYER5_FONT_ASCII_OFFSET => 32,
      C_LAYER5_TEXT_NUM_STRINGS => 8,
      C_LAYER5_TEXT_MAX_STRING_LENGTH => 32,
      C_LAYER6_IMEM_SIZE => 48,
      C_LAYER6_INS_BOX_EN => 1,
      C_LAYER6_INS_LINE_EN => 0,
      C_LAYER6_INS_TEXT_EN => 1,
      C_LAYER6_CLUT_SIZE => 16,
      C_LAYER6_CLUT_MEMTYPE => 2,
      C_LAYER6_FONT_NUM_CHARS => 96,
      C_LAYER6_FONT_WIDTH => 8,
      C_LAYER6_FONT_HEIGHT => 8,
      C_LAYER6_FONT_BPP => 1,
      C_LAYER6_FONT_ASCII_OFFSET => 32,
      C_LAYER6_TEXT_NUM_STRINGS => 8,
      C_LAYER6_TEXT_MAX_STRING_LENGTH => 32,
      C_LAYER7_IMEM_SIZE => 48,
      C_LAYER7_INS_BOX_EN => 1,
      C_LAYER7_INS_LINE_EN => 0,
      C_LAYER7_INS_TEXT_EN => 1,
      C_LAYER7_CLUT_SIZE => 16,
      C_LAYER7_CLUT_MEMTYPE => 2,
      C_LAYER7_FONT_NUM_CHARS => 96,
      C_LAYER7_FONT_WIDTH => 8,
      C_LAYER7_FONT_HEIGHT => 8,
      C_LAYER7_FONT_BPP => 1,
      C_LAYER7_FONT_ASCII_OFFSET => 32,
      C_LAYER7_TEXT_NUM_STRINGS => 8,
      C_LAYER7_TEXT_MAX_STRING_LENGTH => 32,
      C_BASEADDR => X"43a00000",
      C_HIGHADDR => X"43a0ffff",
      C_S_AXI_ADDR_WIDTH => 32,
      C_S_AXI_DATA_WIDTH => 32,
      C_S_AXI_CLK_FREQ_HZ => 74992493,
      C_FAMILY => "zynq"
    )
    port map (
      S_AXI_ACLK => S_AXI_ACLK,
      S_AXI_ARESETN => S_AXI_ARESETN,
      S_AXI_AWADDR => S_AXI_AWADDR,
      S_AXI_AWVALID => S_AXI_AWVALID,
      S_AXI_AWREADY => S_AXI_AWREADY,
      S_AXI_WDATA => S_AXI_WDATA,
      S_AXI_WSTRB => S_AXI_WSTRB,
      S_AXI_WVALID => S_AXI_WVALID,
      S_AXI_WREADY => S_AXI_WREADY,
      S_AXI_BRESP => S_AXI_BRESP,
      S_AXI_BVALID => S_AXI_BVALID,
      S_AXI_BREADY => S_AXI_BREADY,
      S_AXI_ARADDR => S_AXI_ARADDR,
      S_AXI_ARVALID => S_AXI_ARVALID,
      S_AXI_ARREADY => S_AXI_ARREADY,
      S_AXI_RDATA => S_AXI_RDATA,
      S_AXI_RRESP => S_AXI_RRESP,
      S_AXI_RVALID => S_AXI_RVALID,
      S_AXI_RREADY => S_AXI_RREADY,
      IP2INTC_Irpt => IP2INTC_Irpt,
      vblank_in => vblank_in,
      vsync_in => vsync_in,
      hblank_in => hblank_in,
      hsync_in => hsync_in,
      active_video_in => active_video_in,
      active_chroma_in => active_chroma_in,
      video_data_in => video_data_in,
      vfbc_rd0_clk => vfbc_rd0_clk,
      vfbc_rd0_reset => vfbc_rd0_reset,
      vfbc_rd0_read => vfbc_rd0_read,
      vfbc_rd0_data => vfbc_rd0_data,
      vfbc_rd0_empty => vfbc_rd0_empty,
      vfbc_rd1_clk => vfbc_rd1_clk,
      vfbc_rd1_reset => vfbc_rd1_reset,
      vfbc_rd1_read => vfbc_rd1_read,
      vfbc_rd1_data => vfbc_rd1_data,
      vfbc_rd1_empty => vfbc_rd1_empty,
      vfbc_rd2_clk => vfbc_rd2_clk,
      vfbc_rd2_reset => vfbc_rd2_reset,
      vfbc_rd2_read => vfbc_rd2_read,
      vfbc_rd2_data => vfbc_rd2_data,
      vfbc_rd2_empty => vfbc_rd2_empty,
      vfbc_rd3_clk => vfbc_rd3_clk,
      vfbc_rd3_reset => vfbc_rd3_reset,
      vfbc_rd3_read => vfbc_rd3_read,
      vfbc_rd3_data => vfbc_rd3_data,
      vfbc_rd3_empty => vfbc_rd3_empty,
      vfbc_rd4_clk => vfbc_rd4_clk,
      vfbc_rd4_reset => vfbc_rd4_reset,
      vfbc_rd4_read => vfbc_rd4_read,
      vfbc_rd4_data => vfbc_rd4_data,
      vfbc_rd4_empty => vfbc_rd4_empty,
      vfbc_rd5_clk => vfbc_rd5_clk,
      vfbc_rd5_reset => vfbc_rd5_reset,
      vfbc_rd5_read => vfbc_rd5_read,
      vfbc_rd5_data => vfbc_rd5_data,
      vfbc_rd5_empty => vfbc_rd5_empty,
      vfbc_rd6_clk => vfbc_rd6_clk,
      vfbc_rd6_reset => vfbc_rd6_reset,
      vfbc_rd6_read => vfbc_rd6_read,
      vfbc_rd6_data => vfbc_rd6_data,
      vfbc_rd6_empty => vfbc_rd6_empty,
      vfbc_rd7_clk => vfbc_rd7_clk,
      vfbc_rd7_reset => vfbc_rd7_reset,
      vfbc_rd7_read => vfbc_rd7_read,
      vfbc_rd7_data => vfbc_rd7_data,
      vfbc_rd7_empty => vfbc_rd7_empty,
      vfbc_wd_clk => vfbc_wd_clk,
      vfbc_wd_reset => vfbc_wd_reset,
      vfbc_wd_write => vfbc_wd_write,
      vfbc_wd_data => vfbc_wd_data,
      vfbc_wd_almost_full => vfbc_wd_almost_full,
      video_clk_out => video_clk_out,
      vblank_out => vblank_out,
      vsync_out => vsync_out,
      hblank_out => hblank_out,
      hsync_out => hsync_out,
      active_video_out => active_video_out,
      active_chroma_out => active_chroma_out,
      video_data_out => video_data_out,
      clk => clk,
      ce => ce
    );

end architecture STRUCTURE;

