-------------------------------------------------------------------------------
-- system_perf_axi_mm_0_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library perf_axi_mm_v2_00_a;
use perf_axi_mm_v2_00_a.all;

entity system_perf_axi_mm_0_wrapper is
  port (
    S_AXI_ACLK : in std_logic;
    S_AXI_ARESETN : in std_logic;
    S_AXI_AWADDR : in std_logic_vector(31 downto 0);
    S_AXI_AWVALID : in std_logic;
    S_AXI_AWREADY : out std_logic;
    S_AXI_WDATA : in std_logic_vector(31 downto 0);
    S_AXI_WSTRB : in std_logic_vector(3 downto 0);
    S_AXI_WVALID : in std_logic;
    S_AXI_WREADY : out std_logic;
    S_AXI_BRESP : out std_logic_vector(1 downto 0);
    S_AXI_BVALID : out std_logic;
    S_AXI_BREADY : in std_logic;
    S_AXI_ARADDR : in std_logic_vector(31 downto 0);
    S_AXI_ARVALID : in std_logic;
    S_AXI_ARREADY : out std_logic;
    S_AXI_RDATA : out std_logic_vector(31 downto 0);
    S_AXI_RRESP : out std_logic_vector(1 downto 0);
    S_AXI_RVALID : out std_logic;
    S_AXI_RREADY : in std_logic;
    rd0_clk : in std_logic;
    wr0_clk : in std_logic;
    fsync_rd0 : in std_logic;
    fsync_wr0 : in std_logic;
    arvalid0 : in std_logic;
    awvalid0 : in std_logic;
    rvalid0 : in std_logic;
    rready0 : in std_logic;
    wvalid0 : in std_logic;
    wready0 : in std_logic;
    rd1_clk : in std_logic;
    wr1_clk : in std_logic;
    fsync_rd1 : in std_logic;
    fsync_wr1 : in std_logic;
    arvalid1 : in std_logic;
    awvalid1 : in std_logic;
    rvalid1 : in std_logic;
    rready1 : in std_logic;
    wvalid1 : in std_logic;
    wready1 : in std_logic;
    rd2_clk : in std_logic;
    wr2_clk : in std_logic;
    fsync_rd2 : in std_logic;
    fsync_wr2 : in std_logic;
    arvalid2 : in std_logic;
    awvalid2 : in std_logic;
    rvalid2 : in std_logic;
    rready2 : in std_logic;
    wvalid2 : in std_logic;
    wready2 : in std_logic;
    rd3_clk : in std_logic;
    wr3_clk : in std_logic;
    fsync_rd3 : in std_logic;
    fsync_wr3 : in std_logic;
    arvalid3 : in std_logic;
    awvalid3 : in std_logic;
    rvalid3 : in std_logic;
    rready3 : in std_logic;
    wvalid3 : in std_logic;
    wready3 : in std_logic
  );
end system_perf_axi_mm_0_wrapper;

architecture STRUCTURE of system_perf_axi_mm_0_wrapper is

  component perf_axi_mm is
    generic (
      C_FAMILY : STRING;
      C_BASEADDR : std_logic_vector(31 downto 0);
      C_HIGHADDR : std_logic_vector(31 downto 0);
      C_S_AXI_ADDR_WIDTH : INTEGER;
      C_S_AXI_DATA_WIDTH : INTEGER;
      C_NUM_CHANNELS : INTEGER;
      C_MON_FSYNC_MON0 : INTEGER;
      C_MON_FSYNC_MON1 : INTEGER;
      C_MON_FSYNC_MON2 : INTEGER;
      C_MON_FSYNC_MON3 : INTEGER
    );
    port (
      S_AXI_ACLK : in std_logic;
      S_AXI_ARESETN : in std_logic;
      S_AXI_AWADDR : in std_logic_vector((C_S_AXI_ADDR_WIDTH-1) downto 0);
      S_AXI_AWVALID : in std_logic;
      S_AXI_AWREADY : out std_logic;
      S_AXI_WDATA : in std_logic_vector((C_S_AXI_DATA_WIDTH-1) downto 0);
      S_AXI_WSTRB : in std_logic_vector(((C_S_AXI_DATA_WIDTH/8)-1) downto 0);
      S_AXI_WVALID : in std_logic;
      S_AXI_WREADY : out std_logic;
      S_AXI_BRESP : out std_logic_vector(1 downto 0);
      S_AXI_BVALID : out std_logic;
      S_AXI_BREADY : in std_logic;
      S_AXI_ARADDR : in std_logic_vector((C_S_AXI_ADDR_WIDTH-1) downto 0);
      S_AXI_ARVALID : in std_logic;
      S_AXI_ARREADY : out std_logic;
      S_AXI_RDATA : out std_logic_vector((C_S_AXI_DATA_WIDTH-1) downto 0);
      S_AXI_RRESP : out std_logic_vector(1 downto 0);
      S_AXI_RVALID : out std_logic;
      S_AXI_RREADY : in std_logic;
      rd0_clk : in std_logic;
      wr0_clk : in std_logic;
      fsync_rd0 : in std_logic;
      fsync_wr0 : in std_logic;
      arvalid0 : in std_logic;
      awvalid0 : in std_logic;
      rvalid0 : in std_logic;
      rready0 : in std_logic;
      wvalid0 : in std_logic;
      wready0 : in std_logic;
      rd1_clk : in std_logic;
      wr1_clk : in std_logic;
      fsync_rd1 : in std_logic;
      fsync_wr1 : in std_logic;
      arvalid1 : in std_logic;
      awvalid1 : in std_logic;
      rvalid1 : in std_logic;
      rready1 : in std_logic;
      wvalid1 : in std_logic;
      wready1 : in std_logic;
      rd2_clk : in std_logic;
      wr2_clk : in std_logic;
      fsync_rd2 : in std_logic;
      fsync_wr2 : in std_logic;
      arvalid2 : in std_logic;
      awvalid2 : in std_logic;
      rvalid2 : in std_logic;
      rready2 : in std_logic;
      wvalid2 : in std_logic;
      wready2 : in std_logic;
      rd3_clk : in std_logic;
      wr3_clk : in std_logic;
      fsync_rd3 : in std_logic;
      fsync_wr3 : in std_logic;
      arvalid3 : in std_logic;
      awvalid3 : in std_logic;
      rvalid3 : in std_logic;
      rready3 : in std_logic;
      wvalid3 : in std_logic;
      wready3 : in std_logic
    );
  end component;

begin

  perf_axi_mm_0 : perf_axi_mm
    generic map (
      C_FAMILY => "zynq",
      C_BASEADDR => X"41000000",
      C_HIGHADDR => X"4100FFFF",
      C_S_AXI_ADDR_WIDTH => 32,
      C_S_AXI_DATA_WIDTH => 32,
      C_NUM_CHANNELS => 3,
      C_MON_FSYNC_MON0 => 1,
      C_MON_FSYNC_MON1 => 1,
      C_MON_FSYNC_MON2 => 1,
      C_MON_FSYNC_MON3 => 0
    )
    port map (
      S_AXI_ACLK => S_AXI_ACLK,
      S_AXI_ARESETN => S_AXI_ARESETN,
      S_AXI_AWADDR => S_AXI_AWADDR,
      S_AXI_AWVALID => S_AXI_AWVALID,
      S_AXI_AWREADY => S_AXI_AWREADY,
      S_AXI_WDATA => S_AXI_WDATA,
      S_AXI_WSTRB => S_AXI_WSTRB,
      S_AXI_WVALID => S_AXI_WVALID,
      S_AXI_WREADY => S_AXI_WREADY,
      S_AXI_BRESP => S_AXI_BRESP,
      S_AXI_BVALID => S_AXI_BVALID,
      S_AXI_BREADY => S_AXI_BREADY,
      S_AXI_ARADDR => S_AXI_ARADDR,
      S_AXI_ARVALID => S_AXI_ARVALID,
      S_AXI_ARREADY => S_AXI_ARREADY,
      S_AXI_RDATA => S_AXI_RDATA,
      S_AXI_RRESP => S_AXI_RRESP,
      S_AXI_RVALID => S_AXI_RVALID,
      S_AXI_RREADY => S_AXI_RREADY,
      rd0_clk => rd0_clk,
      wr0_clk => wr0_clk,
      fsync_rd0 => fsync_rd0,
      fsync_wr0 => fsync_wr0,
      arvalid0 => arvalid0,
      awvalid0 => awvalid0,
      rvalid0 => rvalid0,
      rready0 => rready0,
      wvalid0 => wvalid0,
      wready0 => wready0,
      rd1_clk => rd1_clk,
      wr1_clk => wr1_clk,
      fsync_rd1 => fsync_rd1,
      fsync_wr1 => fsync_wr1,
      arvalid1 => arvalid1,
      awvalid1 => awvalid1,
      rvalid1 => rvalid1,
      rready1 => rready1,
      wvalid1 => wvalid1,
      wready1 => wready1,
      rd2_clk => rd2_clk,
      wr2_clk => wr2_clk,
      fsync_rd2 => fsync_rd2,
      fsync_wr2 => fsync_wr2,
      arvalid2 => arvalid2,
      awvalid2 => awvalid2,
      rvalid2 => rvalid2,
      rready2 => rready2,
      wvalid2 => wvalid2,
      wready2 => wready2,
      rd3_clk => rd3_clk,
      wr3_clk => wr3_clk,
      fsync_rd3 => fsync_rd3,
      fsync_wr3 => fsync_wr3,
      arvalid3 => arvalid3,
      awvalid3 => awvalid3,
      rvalid3 => rvalid3,
      rready3 => rready3,
      wvalid3 => wvalid3,
      wready3 => wready3
    );

end architecture STRUCTURE;

