//-----------------------------------------------------------------------------
// system_stub.v
//-----------------------------------------------------------------------------

module system_stub
  (
    eps7_0_MIO,
    eps7_0_PS_SRSTB,
    eps7_0_PS_CLK,
    eps7_0_PS_PORB,
    eps7_0_DDR_Clk,
    eps7_0_DDR_Clk_n,
    eps7_0_DDR_CKE,
    eps7_0_DDR_CS_n,
    eps7_0_DDR_RAS_n,
    eps7_0_DDR_CAS_n,
    eps7_0_DDR_WEB_pin,
    eps7_0_DDR_BankAddr,
    eps7_0_DDR_Addr,
    eps7_0_DDR_ODT,
    eps7_0_DDR_DRSTB,
    eps7_0_DDR_DQ,
    eps7_0_DDR_DM,
    eps7_0_DDR_DQS,
    eps7_0_DDR_DQS_n,
    eps7_0_DDR_VRN,
    eps7_0_DDR_VRP,
    ext_hdmi_de,
    ext_hdmi_vsync,
    ext_hdmi_hsync,
    ext_hdmi_data,
    ext_hdmi_clk,
    VIDEO_CLK_P,
    VIDEO_CLK_N
  );
  inout [53:0] eps7_0_MIO;
  input eps7_0_PS_SRSTB;
  input eps7_0_PS_CLK;
  input eps7_0_PS_PORB;
  inout eps7_0_DDR_Clk;
  inout eps7_0_DDR_Clk_n;
  inout eps7_0_DDR_CKE;
  inout eps7_0_DDR_CS_n;
  inout eps7_0_DDR_RAS_n;
  inout eps7_0_DDR_CAS_n;
  output eps7_0_DDR_WEB_pin;
  inout [2:0] eps7_0_DDR_BankAddr;
  inout [14:0] eps7_0_DDR_Addr;
  inout eps7_0_DDR_ODT;
  inout eps7_0_DDR_DRSTB;
  inout [31:0] eps7_0_DDR_DQ;
  inout [3:0] eps7_0_DDR_DM;
  inout [3:0] eps7_0_DDR_DQS;
  inout [3:0] eps7_0_DDR_DQS_n;
  inout eps7_0_DDR_VRN;
  inout eps7_0_DDR_VRP;
  output ext_hdmi_de;
  output ext_hdmi_vsync;
  output ext_hdmi_hsync;
  output [15:0] ext_hdmi_data;
  output ext_hdmi_clk;
  input VIDEO_CLK_P;
  input VIDEO_CLK_N;

  (* BOX_TYPE = "user_black_box" *)
  system
    system_i (
      .eps7_0_MIO ( eps7_0_MIO ),
      .eps7_0_PS_SRSTB ( eps7_0_PS_SRSTB ),
      .eps7_0_PS_CLK ( eps7_0_PS_CLK ),
      .eps7_0_PS_PORB ( eps7_0_PS_PORB ),
      .eps7_0_DDR_Clk ( eps7_0_DDR_Clk ),
      .eps7_0_DDR_Clk_n ( eps7_0_DDR_Clk_n ),
      .eps7_0_DDR_CKE ( eps7_0_DDR_CKE ),
      .eps7_0_DDR_CS_n ( eps7_0_DDR_CS_n ),
      .eps7_0_DDR_RAS_n ( eps7_0_DDR_RAS_n ),
      .eps7_0_DDR_CAS_n ( eps7_0_DDR_CAS_n ),
      .eps7_0_DDR_WEB_pin ( eps7_0_DDR_WEB_pin ),
      .eps7_0_DDR_BankAddr ( eps7_0_DDR_BankAddr ),
      .eps7_0_DDR_Addr ( eps7_0_DDR_Addr ),
      .eps7_0_DDR_ODT ( eps7_0_DDR_ODT ),
      .eps7_0_DDR_DRSTB ( eps7_0_DDR_DRSTB ),
      .eps7_0_DDR_DQ ( eps7_0_DDR_DQ ),
      .eps7_0_DDR_DM ( eps7_0_DDR_DM ),
      .eps7_0_DDR_DQS ( eps7_0_DDR_DQS ),
      .eps7_0_DDR_DQS_n ( eps7_0_DDR_DQS_n ),
      .eps7_0_DDR_VRN ( eps7_0_DDR_VRN ),
      .eps7_0_DDR_VRP ( eps7_0_DDR_VRP ),
      .ext_hdmi_de ( ext_hdmi_de ),
      .ext_hdmi_vsync ( ext_hdmi_vsync ),
      .ext_hdmi_hsync ( ext_hdmi_hsync ),
      .ext_hdmi_data ( ext_hdmi_data ),
      .ext_hdmi_clk ( ext_hdmi_clk ),
      .VIDEO_CLK_P ( VIDEO_CLK_P ),
      .VIDEO_CLK_N ( VIDEO_CLK_N )
    );

endmodule

module system
  (
    eps7_0_MIO,
    eps7_0_PS_SRSTB,
    eps7_0_PS_CLK,
    eps7_0_PS_PORB,
    eps7_0_DDR_Clk,
    eps7_0_DDR_Clk_n,
    eps7_0_DDR_CKE,
    eps7_0_DDR_CS_n,
    eps7_0_DDR_RAS_n,
    eps7_0_DDR_CAS_n,
    eps7_0_DDR_WEB_pin,
    eps7_0_DDR_BankAddr,
    eps7_0_DDR_Addr,
    eps7_0_DDR_ODT,
    eps7_0_DDR_DRSTB,
    eps7_0_DDR_DQ,
    eps7_0_DDR_DM,
    eps7_0_DDR_DQS,
    eps7_0_DDR_DQS_n,
    eps7_0_DDR_VRN,
    eps7_0_DDR_VRP,
    ext_hdmi_de,
    ext_hdmi_vsync,
    ext_hdmi_hsync,
    ext_hdmi_data,
    ext_hdmi_clk,
    VIDEO_CLK_P,
    VIDEO_CLK_N
  );
  inout [53:0] eps7_0_MIO;
  input eps7_0_PS_SRSTB;
  input eps7_0_PS_CLK;
  input eps7_0_PS_PORB;
  inout eps7_0_DDR_Clk;
  inout eps7_0_DDR_Clk_n;
  inout eps7_0_DDR_CKE;
  inout eps7_0_DDR_CS_n;
  inout eps7_0_DDR_RAS_n;
  inout eps7_0_DDR_CAS_n;
  output eps7_0_DDR_WEB_pin;
  inout [2:0] eps7_0_DDR_BankAddr;
  inout [14:0] eps7_0_DDR_Addr;
  inout eps7_0_DDR_ODT;
  inout eps7_0_DDR_DRSTB;
  inout [31:0] eps7_0_DDR_DQ;
  inout [3:0] eps7_0_DDR_DM;
  inout [3:0] eps7_0_DDR_DQS;
  inout [3:0] eps7_0_DDR_DQS_n;
  inout eps7_0_DDR_VRN;
  inout eps7_0_DDR_VRP;
  output ext_hdmi_de;
  output ext_hdmi_vsync;
  output ext_hdmi_hsync;
  output [15:0] ext_hdmi_data;
  output ext_hdmi_clk;
  input VIDEO_CLK_P;
  input VIDEO_CLK_N;
endmodule

