-------------------------------------------------------------------------------
-- system_vfbc2axi_1_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library vfbc2axi_v1_00_e;
use vfbc2axi_v1_00_e.all;

entity system_vfbc2axi_1_wrapper is
  port (
    m_axis_aresetn : in std_logic;
    m_axis_tdata : out std_logic_vector(31 downto 0);
    m_axis_tstrb : out std_logic_vector(3 downto 0);
    m_axis_tvalid : out std_logic;
    m_axis_tready : in std_logic;
    m_axis_tlast : out std_logic;
    fsync_in : in std_logic;
    fsync_out : out std_logic;
    vfbc_wd_clk : in std_logic;
    vfbc_wd_write : in std_logic;
    vfbc_wd_data : in std_logic_vector(31 downto 0);
    vfbc_wd_full : out std_logic;
    s_axis_tdata : in std_logic_vector(31 downto 0);
    s_axis_tvalid : in std_logic;
    s_axis_tready : out std_logic;
    buffer_almost_empty : in std_logic;
    vfbc_rd_clk : in std_logic;
    vfbc_rd_read : in std_logic;
    vfbc_rd_data : out std_logic_vector(31 downto 0);
    vfbc_rd_almost_empty : out std_logic
  );
end system_vfbc2axi_1_wrapper;

architecture STRUCTURE of system_vfbc2axi_1_wrapper is

  component vfbc2axi is
    generic (
      C_M_AXIS_S2MM_TDATA_WIDTH : INTEGER;
      C_S_AXIS_MM2S_TDATA_WIDTH : INTEGER
    );
    port (
      m_axis_aresetn : in std_logic;
      m_axis_tdata : out std_logic_vector(C_M_AXIS_S2MM_TDATA_WIDTH-1 downto 0);
      m_axis_tstrb : out std_logic_vector((C_M_AXIS_S2MM_TDATA_WIDTH/8)-1 downto 0);
      m_axis_tvalid : out std_logic;
      m_axis_tready : in std_logic;
      m_axis_tlast : out std_logic;
      fsync_in : in std_logic;
      fsync_out : out std_logic;
      vfbc_wd_clk : in std_logic;
      vfbc_wd_write : in std_logic;
      vfbc_wd_data : in std_logic_vector(C_M_AXIS_S2MM_TDATA_WIDTH-1 downto 0);
      vfbc_wd_full : out std_logic;
      s_axis_tdata : in std_logic_vector(C_S_AXIS_MM2S_TDATA_WIDTH-1 downto 0);
      s_axis_tvalid : in std_logic;
      s_axis_tready : out std_logic;
      buffer_almost_empty : in std_logic;
      vfbc_rd_clk : in std_logic;
      vfbc_rd_read : in std_logic;
      vfbc_rd_data : out std_logic_vector(C_S_AXIS_MM2S_TDATA_WIDTH-1 downto 0);
      vfbc_rd_almost_empty : out std_logic
    );
  end component;

begin

  vfbc2axi_1 : vfbc2axi
    generic map (
      C_M_AXIS_S2MM_TDATA_WIDTH => 32,
      C_S_AXIS_MM2S_TDATA_WIDTH => 32
    )
    port map (
      m_axis_aresetn => m_axis_aresetn,
      m_axis_tdata => m_axis_tdata,
      m_axis_tstrb => m_axis_tstrb,
      m_axis_tvalid => m_axis_tvalid,
      m_axis_tready => m_axis_tready,
      m_axis_tlast => m_axis_tlast,
      fsync_in => fsync_in,
      fsync_out => fsync_out,
      vfbc_wd_clk => vfbc_wd_clk,
      vfbc_wd_write => vfbc_wd_write,
      vfbc_wd_data => vfbc_wd_data,
      vfbc_wd_full => vfbc_wd_full,
      s_axis_tdata => s_axis_tdata,
      s_axis_tvalid => s_axis_tvalid,
      s_axis_tready => s_axis_tready,
      buffer_almost_empty => buffer_almost_empty,
      vfbc_rd_clk => vfbc_rd_clk,
      vfbc_rd_read => vfbc_rd_read,
      vfbc_rd_data => vfbc_rd_data,
      vfbc_rd_almost_empty => vfbc_rd_almost_empty
    );

end architecture STRUCTURE;

