-------------------------------------------------------------------------------
-- system_xsvi2axi_2_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library xsvi2axi_v1_01_c;
use xsvi2axi_v1_01_c.all;

entity system_xsvi2axi_2_wrapper is
  port (
    m_axis_aresetn : in std_logic;
    m_axis_tdata : out std_logic_vector(31 downto 0);
    m_axis_tstrb : out std_logic_vector(3 downto 0);
    m_axis_tvalid : out std_logic;
    m_axis_tready : in std_logic;
    m_axis_tlast : out std_logic;
    fsync_in : in std_logic;
    video_clk : in std_logic;
    active_video : in std_logic;
    video_data : in std_logic_vector(31 downto 0);
    full : out std_logic;
    fsync_out : out std_logic
  );
end system_xsvi2axi_2_wrapper;

architecture STRUCTURE of system_xsvi2axi_2_wrapper is

  component xsvi2axi is
    generic (
      C_M_AXIS_S2MM_TDATA_WIDTH : INTEGER
    );
    port (
      m_axis_aresetn : in std_logic;
      m_axis_tdata : out std_logic_vector(C_M_AXIS_S2MM_TDATA_WIDTH-1 downto 0);
      m_axis_tstrb : out std_logic_vector((C_M_AXIS_S2MM_TDATA_WIDTH/8)-1 downto 0);
      m_axis_tvalid : out std_logic;
      m_axis_tready : in std_logic;
      m_axis_tlast : out std_logic;
      fsync_in : in std_logic;
      video_clk : in std_logic;
      active_video : in std_logic;
      video_data : in std_logic_vector(C_M_AXIS_S2MM_TDATA_WIDTH-1 downto 0);
      full : out std_logic;
      fsync_out : out std_logic
    );
  end component;

begin

  xsvi2axi_2 : xsvi2axi
    generic map (
      C_M_AXIS_S2MM_TDATA_WIDTH => 32
    )
    port map (
      m_axis_aresetn => m_axis_aresetn,
      m_axis_tdata => m_axis_tdata,
      m_axis_tstrb => m_axis_tstrb,
      m_axis_tvalid => m_axis_tvalid,
      m_axis_tready => m_axis_tready,
      m_axis_tlast => m_axis_tlast,
      fsync_in => fsync_in,
      video_clk => video_clk,
      active_video => active_video,
      video_data => video_data,
      full => full,
      fsync_out => fsync_out
    );

end architecture STRUCTURE;

