-------------------------------------------------------------------------------
-- system_zynq_addr_switch_2_wrapper.vhd
-------------------------------------------------------------------------------
library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

library UNISIM;
use UNISIM.VCOMPONENTS.ALL;

library zynq_addr_switch_v1_00_a;
use zynq_addr_switch_v1_00_a.all;

entity system_zynq_addr_switch_2_wrapper is
  port (
    M0_AXI_AWADDR : in std_logic_vector(31 downto 0);
    M0_AXI_ARADDR : in std_logic_vector(31 downto 0);
    M1_AXI_AWADDR : in std_logic_vector(31 downto 0);
    M1_AXI_ARADDR : in std_logic_vector(31 downto 0);
    S_AXI_AWADDR : out std_logic_vector(63 downto 0);
    S_AXI_ARADDR : out std_logic_vector(63 downto 0)
  );
end system_zynq_addr_switch_2_wrapper;

architecture STRUCTURE of system_zynq_addr_switch_2_wrapper is

  component zynq_addr_switch is
    port (
      M0_AXI_AWADDR : in std_logic_vector(31 downto 0);
      M0_AXI_ARADDR : in std_logic_vector(31 downto 0);
      M1_AXI_AWADDR : in std_logic_vector(31 downto 0);
      M1_AXI_ARADDR : in std_logic_vector(31 downto 0);
      S_AXI_AWADDR : out std_logic_vector(63 downto 0);
      S_AXI_ARADDR : out std_logic_vector(63 downto 0)
    );
  end component;

begin

  zynq_addr_switch_2 : zynq_addr_switch
    port map (
      M0_AXI_AWADDR => M0_AXI_AWADDR,
      M0_AXI_ARADDR => M0_AXI_ARADDR,
      M1_AXI_AWADDR => M1_AXI_AWADDR,
      M1_AXI_ARADDR => M1_AXI_ARADDR,
      S_AXI_AWADDR => S_AXI_AWADDR,
      S_AXI_ARADDR => S_AXI_ARADDR
    );

end architecture STRUCTURE;

