library IEEE;
use IEEE.STD_LOGIC_1164.ALL;

entity prng is
generic 
(
   width       : integer :=  32 
); 
port 
(
   clk         :  in    std_logic;
   seed        :  in    std_logic_vector (width-1 downto 0);
   random_num  :  out   std_logic_vector (width-1 downto 0);
   prst        :  in    std_logic
);
end prng;

architecture Behavioral of prng is
begin

process(clk)
variable rand_temp   : std_logic_vector(width-1 downto 0);
variable temp        : std_logic := '0';
begin
if(rising_edge(clk)) then
   if (prst = '1') then
      rand_temp                     := seed;
   else
      temp                          := rand_temp(width-1) xor rand_temp(width-2);
      rand_temp(width-1 downto 1)   := rand_temp(width-2 downto 0);
      rand_temp(0)                  := temp;
      random_num                    <= rand_temp;
   end if;
end if;

end process;

end Behavioral;
